/*
  xsetaseta@gmail.com
  Juan Galaz
  2/10/2017
  Reloj mediante interrupciones y CT1642
  Compilar en Arduino arduino-1.6.9 , en 1.0.5 la libreria da error
  Palencia / España
*/
#include <CT1642.h>

// Define the CT1642 pins
#define CLOCK_PIN 6
#define DATA_PIN  7
#define KEY_PIN   3

int time1, time2, time3, x;
int key_pressed;

// Setup an instance to communicate the CT1642 IC
CT1642 ledDriver(CLOCK_PIN, DATA_PIN, KEY_PIN);

#include <avr/io.h>
#include <avr/interrupt.h>

int horas, minutos, segundos, dias;
byte bandera = 0, modo;
char time[15];



void setup()
{
  Serial.begin(9600);
  Serial.println("RelojCT1642");

  cli();
  TCCR1A = 0;
  TCCR1B = 0;
  OCR1A = 15624;
  TCCR1B |= (1 << WGM12);
  TCCR1B |= (1 << CS10);
  TCCR1B |= (1 << CS12);
  TIMSK1 = (1 << OCIE1A);
  sei();
  modo = 0;
}

void loop()
{
  time1++; time2++; time3++;

  if (bandera == 1)
  {
    bandera = 0;
    printTime();
  }

  if (time3 > 30)
  {
    time3 = 0;
    key_pressed = ledDriver.getKeyCode();
  }

  if (time2 > 100)
  {
    time2 = 0;
    switch (key_pressed)
    {
      case 2:
        minutos++;
        segundos = 0;
        if (minutos > 59)minutos = 0;
        break;
      case 3:
        if (modo == 0)
          modo = 1;
        else
          modo = 0;
        delay(500);
        break;
      case 5:
        horas++;
        if (horas > 23)horas = 0;
        break;
    }
    if (key_pressed != 0) Serial.println(key_pressed);
  }

  if (time1 > 10)
  {
    time1 = 0;
    if (modo == 0)
      ledDriver.showTime(horas, minutos);
    else
      ledDriver.showNumber(segundos);
  }
}

void printTime()
{
  sprintf(time, "%02d:%02d:%02d", horas, minutos, segundos);
  Serial.println(time);
}

ISR(TIMER1_COMPA_vect)
{
  bandera = 1;
  segundos++;
  if (segundos > 59)
  {
    segundos = 0;
    minutos++;
    if (minutos > 59)
    {
      minutos = 0;
      horas++;
      if (horas > 23)
      {
        segundos = 0;
        minutos = 0;
        horas = 0;
        dias++;
      }
    }
  }
}

